/*
 * Copyright (C) 2016 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.thema.lucsim.gui;

import java.util.ArrayList;

/**
 * Classe qui calcul et affiche la distance entre les deux derniers point clické
 * sur la couche
 *
 * @author alexis
 */
public class DistanceCord extends javax.swing.JPanel {

    /**
     * Creates new form DistanceCord
     */
    public DistanceCord(ArrayList<double[]> arrCoord) {

        initComponents();
        int size = arrCoord.size();
        if (size > 2) {
            double distance = Math.sqrt((arrCoord.get(size - 1)[0] - arrCoord.get(size - 2)[0]) * (arrCoord.get(size - 1)[0] - arrCoord.get(size - 2)[0]) + (arrCoord.get(size - 1)[1] - arrCoord.get(size - 2)[1]) * (arrCoord.get(size - 1)[1] - arrCoord.get(size - 2)[1]));
            distance = (Math.round(distance * Math.pow(10, 4))) / (Math.pow(10, 4));
            zoneDistance.setText("Distance : " + distance + "m");
        } else {
            zoneDistance.setText("Distance : 0 m");
        }

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        zoneDistance = new javax.swing.JTextField();

        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.thema.lucsim.gui.LucsimApp.class).getContext().getResourceMap(DistanceCord.class);
        zoneDistance.setBackground(resourceMap.getColor("zoneDistance.background")); // NOI18N
        zoneDistance.setFont(resourceMap.getFont("zoneDistance.font")); // NOI18N
        zoneDistance.setText(resourceMap.getString("zoneDistance.text")); // NOI18N
        zoneDistance.setName("zoneDistance"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(zoneDistance, javax.swing.GroupLayout.DEFAULT_SIZE, 318, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(zoneDistance, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField zoneDistance;
    // End of variables declaration//GEN-END:variables
}
